/*
    libfame - Fast Assembly MPEG Encoder Library
    Copyright (C) 2000-2001 Vivien Chappelier

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* The default MPEG-1 intra quantization table */
#if defined(HAS_MMX)
/* transpose table */
FAME_ALIGNED static unsigned char mpeg1_intra_quantisation_table[64] = {
      8,16,19,22,22,26,26,27,
     16,16,22,22,26,27,27,29,
     19,22,26,26,27,29,29,35,
     22,24,27,27,29,32,34,38,
     26,27,29,29,32,35,38,46,
     27,29,34,34,35,40,46,56,
     29,34,34,37,40,48,56,69,
     34,37,38,40,48,58,69,83 };
#else
FAME_ALIGNED static unsigned char mpeg1_intra_quantisation_table[64] = {
      8,16,19,22,26,27,29,34,
     16,16,22,24,27,29,34,37,
     19,22,26,27,29,34,34,38,
     22,22,26,27,29,34,37,40,
     22,26,27,29,32,35,40,48,
     26,27,29,32,35,40,48,58,
     26,27,29,34,38,46,56,69,
     27,29,35,38,46,56,69,83 };
#endif

/* The default MPEG-1 inter quantization table */
/* table is symetric */
FAME_ALIGNED static unsigned char mpeg1_inter_quantisation_table[64] = {
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16,
     16,16,16,16,16,16,16,16 };
