/*
    libfame - Fast Assembly MPEG Encoder Library
    Copyright (C) 2000-2001 Vivien Chappelier

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* The default MPEG-4 intra quantization table */
#if defined(HAS_MMX)
/* transpose table */
FAME_ALIGNED static unsigned char mpeg4_intra_quantisation_table[64] = {
      8,17,20,21,22,23,25,27,
     17,18,21,22,23,24,26,28,
     18,19,22,23,24,26,28,30,
     19,21,23,24,26,28,30,32,
     21,23,24,26,28,30,32,35,
     23,25,26,28,30,32,35,38,
     25,27,28,30,32,35,38,41,
     27,28,30,32,35,38,41,45 };
#else
FAME_ALIGNED static unsigned char mpeg4_intra_quantisation_table[64] = {
      8,17,18,19,21,23,25,27,
     17,18,19,21,23,25,27,28,
     20,21,22,23,24,26,28,30,
     21,22,23,24,26,28,30,32,
     22,23,24,26,28,30,32,35,
     23,24,26,28,30,32,35,38,
     25,26,28,30,32,35,38,41,
     27,28,30,32,35,38,41,45 };
#endif

/* The default MPEG-4 inter quantisation table */
/* table is symetric */
FAME_ALIGNED static unsigned char mpeg4_inter_quantisation_table[64] = {
     16,17,18,19,20,21,22,23,
     17,18,19,20,21,22,23,24,
     18,19,20,21,22,23,24,25,
     19,20,21,22,23,24,26,27,
     20,21,22,23,25,26,27,28,
     21,22,23,24,26,27,28,30,
     22,23,24,26,27,28,30,31,
     23,24,25,27,28,30,31,33 };
